#!/usr/bin/python

import sys,re,commands,time

import httplib, string
import os.path
from ConfigParser import ConfigParser
import CommandLine
from base64 import encodestring
import commands,rfc822,socket
import logging

TRUE  = 1
FALSE = 0
__version__ = "2.0"

class CommonUtils:
    is_execute = 1

    #Flag for checking if the debug messages are to be displayed.
    is_log = 0

    #Flag for checking if the debug messages are to be displayed.
    is_debug = 0
    #Flag for checking if the verbose messages are to be displayed.
    is_verbose = 0

    def __init__(self,name,help, commandline_opts = [], commandline_args = [],
                 version="", argv=None):

        self.cmd = CommandLine.Command(name, help,
                                       options=commandline_opts,
                                       arguments=commandline_args)
        self.cmd.parse()
        
    def out(self, msg):
        """Print msg if verbose is set."""
        #if self.is_verbose == 1:
        if msg != None:
           print msg.rstrip()

    def execute_cmd(self,cmd,logs=''):
        if self.is_debug == 1:
           self.out("Command: %s" % cmd)

        if not(os.path.isdir(logs)):
           try:
              os.makedirs(logs)
           except:
              pass

        if self.is_execute == 0:
           self.out("Execute is disabled: Hence NOT EXECUTING COMMAND")
           cmd = 'echo'

        ret = self.getcommandoutput_(cmd)

        if (logs):
           try:
              #items = cmd.split(" ")
              filename = cmd.replace(" " ,"_")
              filename = filename.replace("./" ,"")
              filename = filename.replace("/" ,"_")
              filename = filename.replace("-" ,"_")
              filename = filename + "_cmd.log"
              #filename = str(items[0]) + '_cmd'
           except:
              filename = cmd

           #Remove the redirection operator from the cmd, if any 
           try:
              items = filename.split(">")
              filename = items[0]
           except: pass

           filename = os.path.join(logs, filename)
           try:
              wfh = open(filename, "w")
              wfh.write(ret[1])
              wfh.close()
           except:
              self.out("Unable to create log file %s" % (filename))
        return ret

    def enable_verbose(self):
        self.is_verbose = 1

    def disable_verbose(self):
        self.is_verbose = 0

    def enable_execute(self):
        self.out("Enabling Execute")
        self.is_execute = 1

    def disable_execute(self):
        self.out("Disabling Execute")
        self.is_execute = 0

    def enable_log(self):
        self.out("Enabling Log Generation")
        self.is_log= 1

    def disable_log(self):
        self.out("Disabling Log Generation")
        self.is_log = 0

    def enable_debug(self):
        self.out("Enabling Debug Display")
        self.is_debug = 1

    def disable_debug(self):
        self.out("Disabling Debug Display")
        self.is_debug = 0

    def getcommandoutput_(self,cmd):
        if os.name == 'nt':
           child = os.popen(cmd)
           data = child.read()
           err = child.close()
           if err:
              return 1,err
           return 0,data
        else:
           return commands.getstatusoutput(cmd)
