#!/usr/bin/python

import sys, re, string, smtplib
from email.MIMEText import MIMEText

RELENGERR = {}
#Sanity/Config
RELENGERR[001]   = ['Sanity', 'Config', 'e', 'Configuration file is missing. This tool needs a config file to proceed.\nIf you don\'t have a releng.conf in the current path, try passing the config file as a parameter.']
RELENGERR[002]   = ['Sanity', 'Config', 'e', 'Invalid configuration file. Some of the mandatory parameters required are missing.']
RELENGERR[003]   = ['Sanity', 'Config', 'e', 'The argument %s is missing. This argument is required for the installer to proceed.']
RELENGERR[005]   = ['Sanity', 'Config', 'e', 'Only a PostgreSQL database can be used in a dedicated install.']
RELENGERR[006]   = ['Sanity', 'Config', 'e', 'The bootstrap (-b) option cannot be used for advanced installs. Please run ./bootstrap.sh with appropriate arguments to bootstrap the site.']
RELENGERR[007]   = ['Sanity', 'Config', 'e', 'Unable to construct the platform string due to the following reason:\n%s']

# NetworkUtil
RELENGERR[100]   = ['NetworkUtil', 'COMM', 'e' , 'Cannot execute the %s command.']
RELENGERR[101]   = ['NetworkUtil', 'COMM', 'e' , 'Cannot import the %s module. ']
RELENGERR[102]   = ['NetworkUtil', 'SSL', 'e' , 'SSH could not log in. Here is what SSH said: \n%s']
RELENGERR[103]   = ['NetworkUtil', 'PBL', 'e' , 'Can\'t upload files using PBL method.']
RELENGERR[104]   = ['NetworkUtil', 'HTTP', 'e' , 'Cannot connect to the proxy server %s on port %s.']
RELENGERR[105]   = ['NetworkUtil', 'HTTP', 'e' , 'Cannot authenticate to the proxy server with the username and password given.']
RELENGERR[106]   = ['NetworkUtil', 'HTTP', 'e' , 'Cannot download package from URL %s']
RELENGERR[107]   = ['NetworkUtil', 'SVN', 'e' , 'Cannot execute SVN command %s.']
RELENGERR[108]   = ['NetworkUtil', 'SVN', 'e' , '']
RELENGERR[109]   = ['NetworkUtil', 'CVS', 'e' , 'Cannot execute CVS command %s.']
RELENGERR[110]   = ['NetworkUtil', 'CVS', 'e' , '']
RELENGERR[111]   = ['NetworkUtil', 'SSL', 'e' , 'Cannot Connect \n %s.']
RELENGERR[112]   = ['NetworkUtil', 'SSH', 'e' , 'Invalid host or command.']
RELENGERR[113]   = ['NetworkUtil', 'PROXY', 'e', '\n\n**** Cannot connect to the proxy server %s on port %s. ****\n\n']
RELENGERR[114]   = ['NetworkUtil', 'CHECKSUM', 'e', 'Checksum failed. Quitting.']
RELENGERR[115]   = ['NetworkUtil', 'SANITY', 'e', 'One of the mandatory parameters for downloading a file is missing.']
RELENGERR[116]   = ['NetworkUtil', 'PROXY', 'e', '\n\n****Cannot authenticate to the proxy server with the username and password given. ****\n\n']

# RelengCommon
RELENGERR[200]   = ['RelengCommon', 'get_cmd_path', 'e', 'Invalid command. Cannot get command path.']
RELENGERR[201]   = ['RelengCommon', 'su_root', 'e', 'Cannot switch to sudo user.']
RELENGERR[202]   = ['RelengCommon', 'get_patch_file', 'e', 'Cannot ']
RELENGERR[203]   = ['RelengCommon', 'get_option', 'e', 'No prompt for license terms agreement.']
RELENGERR[204]   = ['RelengCommon', 'run_cmd', 'e', 'Execute is disabled. Not executing command.']
RELENGERR[205]   = ['RelengCommon', 'run_cmd', 'e', 'Cannot create log file %s.']
RELENGERR[206]   = ['RelengCommon', 'create_directory', 'w', 'Path already exists and will be overridden.']
RELENGERR[207]   = ['RelengCommon', 'create_directory', 'e', 'Cannot create directory %s.']
RELENGERR[208]   = ['RelengCommon', 'send_mail', 'e', 'Cannot create mimetext instance.']
RELENGERR[209]   = ['RelengCommon', 'create_file', 'm', 'File already exists.']
RELENGERR[210]   = ['RelengCommon', 'create_file', 'e', 'Cannot create file %s.']
RELENGERR[211]   = ['RelengCommon', 'remove_file', 'e', 'Cannot remove file %s']
RELENGERR[212]   = ['RelengCommon', 'remove_file', 'w', 'This file does not exist: %s']
RELENGERR[213]   = ['RelengCommon', 'remove_directory', 'e', 'Cannot remove directory %s.']
RELENGERR[214]   = ['RelengCommon', 'remove_directory', 'w', 'This directory does not exist: %s']
RELENGERR[215]   = ['RelengCommon', 'change_directory', 'e', 'Cannot change to directory %s.']
RELENGERR[216]   = ['RelengCommon', 'unite_path', 'e', 'Cannot identify paths for joining.']
RELENGERR[217]   = ['RelengCommon', 'copy_file', 'e', 'Cannot copy file %s to %s.']
RELENGERR[218]   = ['RelengCommon', 'compress', 'e', 'Cannot find the command for performing compression.']
RELENGERR[219]   = ['RelengCommon', 'read_file', 'e', 'Cannot read file %s.']
RELENGERR[220]   = ['RelengCommon', 'write_file', 'e', 'Cannot write to file %s.']
RELENGERR[221]   = ['RelengCommon', 'checkPkgs', 'e', 'Directory does not exist: %s']
RELENGERR[222]   = ['RelengCommon', 'checkPkgs', 'e', 'Package: %s is not available for installation.']
RELENGERR[223]   = ['RelengCommon', 'checkInstalledPkgs', 'e', 'Package(s): %s are already installed in the system.']

#RelengUtil
RELENGERR[300]   = ['RelengUtil', 'RelengUtil', 'e', 'Insufficient parameters passed to parse the command-line arguments.']
RELENGERR[301]   = ['RelengUtil', 'RelengUtil', 'e', 'Parameters for parsing the command-line arguments are missing.']
RELENGERR[302]   = ['RelengUtil', 'CommandLineParser', 'e', 'This error occured while parsing the command-line arguments:\n%s']

#PrepareWC
RELENGERR[400]   = ['PrepareWC', 'run_svn_cmd', 'e', 'Failed to create tag because:\n%s']
RELENGERR[401]   = ['PrepareWC', 'run_svn_cmd', 'e', 'Failed to switch to the location because:\n%s']
RELENGERR[402]   = ['PrepareWC', 'update_token', 'e', 'Problems encountered while updating token %s in %s.']
RELENGERR[403]   = ['PrepareWC', 'run_svn_cmd', 'e', 'Cannot create svn directory %s because:\n%s']
RELENGERR[404]   = ['PrepareWC', 'run_svn_cmd' , 'e', 'Problems encountered while committing file %s.']
RELENGERR[405]   = ['PrepareWC', 'do_fetch_checkout', 'e', 'Error parsing the repository host %s.']
RELENGERR[406]   = ['PrepareWC', 'get_version_info', 'e', 'Cannot fetch version info.']
RELENGERR[407]   = ['PrepareWC', 'get_version_info', 'e', 'Cannot read token %s from file %s.']
RELENGERR[408]   = ['PrepareWC', 'bootstrap_build', 'e', 'Problems encountered while trying to checkout URL\n %s']
RELENGERR[409]   = ['PrepareWC', 'run_svn_cmd', 'e', 'Cannot list the svn repository %s because:\n%s']

#Installer
RELENGERR[700]   = ['Installer', 'path_exist', 'e', 'File not found: %s']
RELENGERR[701]   = ['Installer', 'sanity', 'e', 'The installation directory parameter is missing. This parameter is required.']
RELENGERR[702]   = ['Installer', 'sanity', 'e', 'The domain parameter is missing. This parameter is required.']
RELENGERR[703]   = ['Installer', 'sanity', 'e', 'Sanity check failed with this error: \n%s']
RELENGERR[704]   = ['Installer', 'sanity', 'e', 'Cannot read SELinux config file in \n %s']
RELENGERR[705]   = ['Installer', 'sanity', 'e', 'Cannot update SELinux config file in \n %s.']
RELENGERR[706]   = ['Installer', 'package_install', 'e', 'Cannot install package due to this error:\n %s']
RELENGERR[708]   = ['Installer', 'set_init', 'e', 'Problem encountered in setting up init script:\n %s']
RELENGERR[709]   = ['Installer', 'start_appication', 'e', 'Problem encountered while starting the application:\n %s' ]
RELENGERR[710]   = ['Installer', 'remove_directory', 'e', 'Cannot remove directory %s for reinstallation.']
RELENGERR[711]   = ['Installer', 'force_option', 'e', 'Fatal error while executing --force option.']
RELENGERR[712]   = ['Installer', 'kill process', 'e', 'Cannot kill java processes during cleanup.']
RELENGERR[713]   = ['Installer', 'site_directory', 'e', 'The install directory specified by -d option is wrong. Please specify -d %s' ]
RELENGERR[714]   = ['Installer', 'uninstall_site', 'e', 'The uninstall option (-u | --uninstall) cannot be used with any other option. Please correct this and retry the installation script.\n']
RELENGERR[715]   = ['Installer', 'cleanup', 'e', 'The runtime option (-r | --runtime) can be used with the cleanup option (-C | --cleanup) only if the install option  (-i | --install) is also used.']
RELENGERR[716]   = ['Installer', 'force_uninstall', 'e', 'Fatal error while performing force uninstall.']
RELENGERR[717]   = ['Installer', 'sanity', 'e', 'Cannot validate site directory.']
RELENGERR[719]   = ['Installer', 'environment_check', 'e', 'Cannot perform environment check']
RELENGERR[720]   = ['Installer', 'environment_check', 'e', 'A package to be installed, %s, cannot be found under %s.']
RELENGERR[721]   = ['Installer', 'sanity', 'e', 'The %s token in site-options.conf cannot be empty.']
RELENGERR[722]   = ['Installer', 'sanity', 'e', 'The path %s does not exist.']
RELENGERR[723]   = ['Installer', 'cleanup', 'e', 'Fatal error while performing cleanup.']
RELENGERR[725]   = ['Installer', 'sanity', 'e', 'The file .skip-env was found while installing. This is probably because the last uninstall was not clean. Please uninstall using the (-u | --uninstall) option, then try again.']
RELENGERR[726]   = ['Installer', 'sanity', 'e', 'This installer is not compatible with your operating system.']
RELENGERR[727]   = ['Installer', 'install', 'e', 'The packages are already on the system due to an incomplete installation. Choose one of these options:\n1. Uninstall the existing rpms and start a fresh install.\n2. If the previous installation used the same installer, run the installer with the force-install option (-F | --force).\n3. Run the installer with the cleanup option (-C | --cleanup) and do a new installation. (NOTE: This will wipe the installation directory).\n4. If you are sure the installation is good, run the installer again with the create reuntime (-r | --runtime) option.']
RELENGERR[728]   = ['Installer', 'install', 'e', 'This is probably due to the following reasons:\n1. An older version of the installation already exists.\n2. The %s package is essential for this installation, but is missing.\nChoose one of these options:\n1. Run the installer with the cleanup command (-C | --cleanup) and start a new installation. (NOTE: This will wipe the installation directory).\n2. Run the installer with the force option (--force | -F).\n3. If an older version of the installation exists, remove it with the uninstall option (--uninstall | -u) start a new installation.']
RELENGERR[729]   = ['Installer', 'install', 'e', 'The installation is garbled. The package %s does not work this installer.\nChoose one of these options:\n1. Run the installer with the cleanup option (-C | --cleanup) and start a new installation. (NOTE: This will wipe the installation directory).\n2. Run the installer with the force option (--force | -F).']
RELENGERR[730]   = ['Installer', 'install', 'e', 'The packages are already on the system. Choose one of these options:\n1. Run the installer with the recreate runtime option (-r | --runtime).\n2. If you are not sure about the installation, run the installer again with the force option (-F | --force).']
RELENGERR[731]   = ['Installer', 'sanity', 'e', 'The options provided cannot go together.']
RELENGERR[733]   = ['Installer', 'sanity', 'e', 'Cannot resolve the hostname %s.']
RELENGERR[734]   = ['Installer', 'sanity', 'e', 'User aborted installation. To run the installer in non-dedicated mode, change the value of the DEDICATED_INSTALL token in conf/site-options.conf to "false" and run the installer again.']
RELENGERR[735]   = ['Installer', 'bootstrap', 'e', 'The following error occurred while trying to bootstrap the site:\n%s']
RELENGERR[736]   = ['Installer', 'sanity', 'e', 'JAVA HOME is not set in site-options.conf file.']
RELENGERR[737]   = ['Installer', 'sanity', 'e', 'The value of JAVA_HOME=%s in site_options.conf indicates a version different from that of the one currently installed on the system. Please either update site_options.conf to reflect the version currently installed, or remove the installed Java RPM']
RELENGERR[739]   = ['Installer', 'sanity', 'e', 'Test-run option can go with patch option only.']
RELENGERR[740]   = ['Installer', 'sanity', 'e', 'Multiple entries found in site-options.conf file for the token \"%s\"']
RELENGERR[741]   = ['Installer', 'sanity', 'e', 'site-options.conf file is missing for continuing installation.']
RELENGERR[742]   = ['Installer', 'sanity', 'e', 'postgres upgrade failed.']
RELENGERR[743]   = ['Installer', 'sanity', 'e', 'You might have to resolve these conflicts manually to continue installation.']
RELENGERR[744]   = ['Installer', 'sanity', 'e', 'Following problem occurred while erasing the conflicting packages. Please resolve them manually and continue CTF installation.\n\n%s.']
RELENGERR[745]   = ['Installer', 'sanity', 'e', 'Unable to refresh repositories, Please fix it & rerun this script.\n']
RELENGERR[746]   = ['Installer', 'install', 'w', 'Aborted the create runtime. If you want to proceed ignoring this check, run with the force-install option (-F | --force)!\n']


#CommonUtils
RELENGERR[901]   = ['CommonUtils', 'parameter', 'e', 'One of the auto-installation configuration parameters is wrong: %s (']
RELENGERR[902]   = ['CommonUtils', 'create_path', 'e', 'Cannot create one of the required paths: %s= '] 
RELENGERR[903]   = ['CommonUtils', 'user', 'e', 'You must be the root user to execute this script.']
RELENGERR[904]   = ['CommonUtils', 'download', 'e', 'Cannot download %s. Try one of these options:\n1. Verify that this machine can reach the Internet.\n2. Check the URL and the checksum for this package in the environment-<platform>.conf file.\n3. If you cannot clear the problem, contact CollabNet support.']
RELENGERR[905]   = ['CommonUtils', 'download', 'e', ' %s already exists. Skipping the download.']
RELENGERR[906]   = ['CommonUtils', 'create_log', 'e', 'Cannot create log file %s.']
RELENGERR[907]   = ['CommonUtils', 'install', 'e', '%s :Installation not found.']
RELENGERR[908]   = ['CommonUtils', 'check_rpm', 'w', 'Cannot check rpm installation for %s.']
RELENGERR[909]   = ['CommonUtils', 'create_folder', 'e', 'Cannot create folder %s.']
RELENGERR[910]   = ['CommonUtils', 'exist', 'w', 'The path already exists and will be overridden.']
RELENGERR[911]   = ['CommonUtils', 'file', 'e', 'File not available in path %s.']
RELENGERR[912]   = ['CommonUtils', 'Config_Error', 'e', 'Section %s invalid for this file format.']
RELENGERR[913]   = ['CommonUtils', 'Config_Error', 'e', 'Option %s occurs too many times in section %s.']
RELENGERR[914]   = ['CommonUtils', 'Config_Error', 'e', 'Option %s required in section %s.']
RELENGERR[915]   = ['CommonUtils', 'error_cause', 'e', 'Problem due to \n %s']
RELENGERR[915]   = ['CommonUtils', 'fatal', 'e', 'Fatal error encountered. Exiting.']
RELENGERR[916]   = ['CommonUtils', 'build', 'e', 'Fatal error encountered while building package %s.']
RELENGERR[917]   = ['CommonUtils', 'build', 'e', 'Cannot create directory %s to extract the archive.']
RELENGERR[918]   = ['CommonUtils', 'build', 'e', 'Cannot extract the archive %s.']
RELENGERR[919]   = ['CommonUtils', 'download' 'e', 'The CollabNet installer extraction path has more than one directory. Please remove all the directories in the <[TEMP]/cee> directory and restart setup.sh']

#CommonUtils
RELENGERR[1001]  = ['CommonUtils', 'ArgumentError', 'e', 'No key provided for arg %s.']
RELENGERR[1002]  = ['CommonUtils', 'ArgumentError', 'e', 'Bad type %s in arg %s.']
RELENGERR[1003]  = ['CommonUtils', 'ArgumentError', 'e', 'Bad occurance %s arg %s']
RELENGERR[1004]  = ['CommonUtils', 'ArgumentError', 'e', 'No validation list provided for %s.']
RELENGERR[1005]  = ['CommonUtils', 'ArgumentError', 'e', '%s is an invalid value for %s.']
RELENGERR[1006]  = ['CommonUtils', 'OptionError', 'e', 'Illegal option %s']
RELENGERR[1007]  = ['CommonUtils', 'OptionError', 'e', 'No key provided for option %s.']
RELENGERR[1008]  = ['CommonUtils', 'OptionError', 'e', 'Bad type %s in option %s.']
RELENGERR[1009]  = ['CommonUtils', 'OptionError', 'e', 'No validation list provided for %s.']
RELENGERR[1010]  = ['CommonUtils', 'OptionError', 'e', 'No argument name provided for %s.']
RELENGERR[1011]  = ['CommonUtils', 'ParseError', 'e', 'There is no %s option.'] 
RELENGERR[1012]  = ['CommonUtils', 'ParseError', 'e', 'The %s option requires a value.'] 
RELENGERR[1013]  = ['CommonUtils', 'ParseError', 'e', 'The %s option doesn\'t take a value.'] 
RELENGERR[1014]  = ['CommonUtils', 'ParseError', 'e', 'Missing required argument: %s.'] 
RELENGERR[1015]  = ['CommonUtils', 'ParseError', 'e', '%s'] 
RELENGERR[1016]  = ['CommonUtils', 'ParseError', 'e', 'Nothing to do with %s.'] 
RELENGERR[1017]  = ['CommonUtils', 'ParseError', 'e', '%s'] 
RELENGERR[1018]  = ['CommonUtils', 'ParseError', 'e', '%s'] 
#ProcessPkgs
RELENGERR[800]   = ['ProcessPkgs', 'copy', 'e', 'Cannot copy %s to %s: %s']
RELENGERR[801]   = ['ProcessPkgs', 'parsing', 'e', 'Token %s unknown.']
RELENGERR[802]   = ['ProcessPkgs', 'process_close', 'e', '%s failed with exit code %d\nStd Err: %s \n']
RELENGERR[803]   = ['ProcessPkgs', '', 'e', 'Multiple entries found:\n\n %s \n\nPlease set %s and %s tokens to the correct values in the configuration file.\n"']
RELENGERR[804]   = ['ProcessPkgs', 'mysql_path', 'w', 'Nonstandard cee mysql path %s']
RELENGERR[805]   = ['ProcessPkgs', 'mysql_path', 'w', 'Nonstandard reporting mysql path %s']
RELENGERR[806]   = ['ProcessPkgs', 'execution', 'e', 'Problem in executing %s \n Error %s']
RELENGERR[807]   = ['ProcessPkgs', 'remove', 'e', 'Cannot remove %s.']
RELENGERR[808]   = ['ProcessPkgs', 'conf_file_error', 'e', 'Installation failed using %s. Please look at it and delete by hand.']
RELENGERR[809]   = ['ProcessPkgs', 'start-stop', 'm', '\n\nRUNTIME_DIR not found. Assuming no start/stop application.\n\n']
RELENGERR[811]   = ['ProcessPkgs', 'rpm_install', 'e', 'Problem installing %s. \n Error %s']
RELENGERR[812]   = ['ProcessPkgs', 'rpm_uninstall', 'e', 'Problem uninstalling %s. \n Error %s']
RELENGERR[813]   = ['ProcessPkgs', 'fatal', 'e', 'The package %s is not in the distribution.']
RELENGERR[814]   = ['ProcessPkgs', 'fatal', 'e', 'The specified tempdir %s does not exist.']
RELENGERR[815]   = ['ProcessPkgs', 'extract', 'e', 'File %s could not extracted.']
RELENGERR[816]   = ['ProcessPkgs', 'pkg_info', 'e', 'The package %s already exists. \n Please check the version already installed.\n You can either uninstall the existing package(s) or re-run the installer without the -i option.']
RELENGERR[817]   = ['ProcessPkgs', 'pkg_add', 'e', 'Package %s could not be added to the system.'] 
RELENGERR[818]   = ['ProcessPkgs', 'remove_directory', 'w', 'Cannot remove %s from %s: %s']
RELENGERR[819]   = ['ProcessPkgs', 'install', 'e', 'Cannot install %s: Unsupported format.']
RELENGERR[820]   = ['ProcessPkgs', 'verify_pkg', 'e', 'Cannot verify package %s. \nCannot handle platform id %s.']
RELENGERR[821]   = ['ProcessPkgs', 'user_input', 'm', '\nYou must provide a valid value %s. Please try again.\n']
RELENGERR[822]   = ['ProcessPkgs', 'extract', 'e', '%s is not a valid response. Valid values are: %s']
RELENGERR[823]   = ['ProcessPkgs', 'exiting', 'e', 'Exiting uninstall without completing.\n']
RELENGERR[824]   = ['ProcessPkgs', 'extract', 'w', 'Cannot find uninstall script at %s.\nCannot remove cron entries (and handle other uninstall logic) without a valid install directory. \nPerhaps the directory specified is incorrect?\nWARNING\n\nContinue with the uninstall anyway? ']
RELENGERR[826]   = ['ProcessPkgs', 'installLinuxRPM/installPackage', 'e', 'Cannot locate the package(s) in: %s']
RELENGERR[827]   = ['ProcessPkgs', 'install_yum_pkg/check_yum_pkg', 'e', 'Following error occurred in package: %s while using package manager\n%s.\n\nThe package %s will be installed from the %s package repository. Please check if the repository is configured properly.']
RELENGERR[828]   = ['ProcessPkgs', 'check_yum_pkg', 'e', 'Cannot locate the package in the package repository server.']
RELENGERR[829]   = ['ProcessPkgs', 'clear_conflicts', 'e', 'Cannot remove the package: %s']
RELENGERR[830]   = ['ProcessPkgs', 'check_tolerance', 'e', 'The application will not support the package %s with version %s. Please remove the package manually and clear dependencies, then rerun the installer.']
RELENGERR[832]   = ['ProcessPkgs', 'check_tolerance', 'e', 'The installer supports the package %s in the %s version range only.']
RELENGERR[833]   = ['ProcessPkgs', 'check_tolerance', 'e', 'Following problem occurred while upgrading the packages with package manager. Please resolve them manually before proceeding further.\n%s']
RELENGERR[834]   = ['ProcessPkgs', 'check_sha1sum', 'e', 'Unable to get the checksum of %s from %s/%s.']
RELENGERR[835] = ['ProcessPkgs', 'check_sha1sum', 'e', 'Unable to get the checksum of %s %s']
RELENGERR[836] = ['ProcessPkgs', 'check_sha1sum', 'e', 'The checksum of %s that is downloaded does not match with the checksum in the package repository. Please retry installation.']

#Build
RELENGERR[500]   = ['Build', 'build_target', 'e', 'Build failed with compilation errors while calling the target %s. Please find the build log at %s.']

#CreateInstaller
RELENGERR[600]   = ['CreateInstaller', 'assemble_installer', 'e', 'Cannot locate target directory %s for deletion.']
RELENGERR[601]   = ['CreateInstaller', 'copy_installer_packages', 'e', 'Error while trying to copy files of type %s in %s.']
RELENGERR[602]   = ['CreateInstaller', 'runInstaller', 'e', 'Cannot locate the script %s in %s.']
RELENGERR[603]   = ['CreateInstaller', 'runInstaller', 'e', 'This error occurred while executing the script: %s\n%s']
RELENGERR[604]   = ['CreateInstaller' , 'get_installer_module', 'e', 'Checkout of CEE install scripts failed with this error:\n%s']
RELENGERR[605]   = ['CreateInstaller', 'extractEnvPkg', 'e', 'Cannot extract the environment package.']
RELENGERR[606]   = ['CreateInstaller', 'get_commit_report', 'e', 'Cannot locate file %s for generating commit report.']
RELENGERR[607]   = ['CreateInstaller', 'create_ocn_build_conf', 'e', 'Cannot write to file %s']

#Patch
RELENGERR[1101]   = ['Patch','sanity','e','The patch level is out of sync. You are trying to install %s but previously have only installed %s.']
RELENGERR[1102]   = ['Patch','sanity' , 'e', 'The %s option cannot be used with any other option. Please retry the patch upgrade script with the correct set of options.']
RELENGERR[1103]   = ['Patch','sanity' , 'e', 'Manifest file(s) [%s] not found.']
RELENGERR[1104]   = ['Patch','sanity' , 'e', 'Invalid manifest file - %s']
RELENGERR[1105]   = ['Patch','sanity' , 'e' , 'Invalid installed directory path for application.']
RELENGERR[1106]   = ['Patch','sanity' , 'e' , 'You are at level %s. Cannot perform uninstall. ']
RELENGERR[1107]   = ['Patch','sanity' , 'e' , 'Installation directory incomplete. The path %s is missing.']
RELENGERR[1108]   = ['Patch','sanity' , 'e' , 'You are at level %s. Cannot find the patches file.']
RELENGERR[1109]   = ['Patch','sanity' , 'e' , 'Cannot read token. File %s not found.']
RELENGERR[1110]   = ['Patch','sanity' , 'e' , 'Required manifest file %s not found.']
RELENGERR[1111]   = ['Patch','sanity' , 'e' , 'manifest-0 is invalid.']
RELENGERR[1112]   = ['Patch','sanity' , 'e' , 'Manifest file format is not valid. Manifest file name must be in this format: manifest-n, where n is the level number.']
RELENGERR[1113]   = ['Patch','component', 'e', 'The package %s to be uninstalled could not be found on the system.']
RELENGERR[1114]   = ['Patch','component', 'e', 'The package %s to be installed is already on the system.']
RELENGERR[1115]   = ['Patch','component', 'e', 'Mandatory parameters missing in environment config file for package/file %s.']
RELENGERR[1116]   = ['Patch','component', 'e', 'The patch file %s to be installed is not found under %s.']
RELENGERR[1117]   = ['Patch','component', 'e', 'Cannot find the package %s on the system.']
RELENGERR[1118]   = ['Patch','component', 'e', 'These packages %s are missing. This is probably because your base installation is corrupted. You may have to redo your base installation before proceeding. See help.collab.net for troubleshooting help.']
RELENGERR[1119] = ['Patch','runtime', 'e', 'TeamForge application could not be stopped.\n Please check the installation directory or stop it manually by running the "collabnet stop" command from the command line.']
RELENGERR[1120] = ['Patch','runtime', 'e', 'TeamForge application could not be started \n.Please check the installation directory or start it manually by running the "collabnet start" commands from the command line. \n']
RELENGERR[1121] = ['Patch','component', 'e', 'APPLICATION_VERSION: %s is not valid.']
RELENGERR[1122] = ['Patch','manifest', 'e', 'Platform string cannot be empty.']
RELENGERR[1123] = ['Patch','getAppVersion', 'e', 'Your installation may be corrupt. Please check the TF install.']
RELENGERR[1124] = ['Patch', 'check_yum', 'e', 'User aborted installation. Please perform the above steps manually if the system is to be downgraded to the required patch level.']

#Instance set
RELENGERR[1200] = ['Inst_set', 'sanity', 'e', 'An instance is installed. Cannot install another until it is uninstalled.']
RELENGERR[1201] = ['Inst_set', 'sanity', 'e', 'No instance is installed. Cannot uninstall.']
RELENGERR[1202] = ['Inst_set', 'sanity', 'e', 'The instance that is installed (%s) does not match the current instance (%s).']
RELENGERR[1203] = ['Inst_set', 'component', 'e', 'The package %s could not be found in the existing system. Uninstall is not possible if the instance set is not installed.']
RELENGERR[1204] = ['Inst_set', 'component', 'e', 'The package %s could not be found in the instance-set directory. Please verify the instance set and try again.']

#Downloader
RELENGERR[1300] = ['Downloader', 'prompt_user_passwd', 'e', 'Unauthorized username/password to download. Please verify the values in environment-<platform>.conf.']
RELENGERR[1301] = ['Downloader', 'validate', 'e', 'One of the mandatory parameters for downloading a file is missing.']
RELENGERR[1302] = ['Downloader', 'run', 'e', 'Cannot create %s directory.']
RELENGERR[1303] = ['Downloader', 'run', 'e', 'Cannot connect to the proxy server %s on port %s.']
RELENGERR[1304] = ['Downloader', 'run', 'e', 'Cannot authenticate to the proxy server with the given username and password. Please verify the environment-<platform>.conf file.']
RELENGERR[1305] = ['Downloader', 'run', 'e', 'Cannot download package from URL %s']


TROUBLESHOOT_URL = 'http://help.collab.net'

def make_str(code, *args):
    if RELENGERR.has_key(code):
        RELENGERR[1000] = [code, RELENGERR[code][2], RELENGERR[code][2], (RELENGERR[code][3] % (args))]

class RelengErr(Exception):

    def __init__(self, ErrMessage=None, ErrType=None, exit=0):
        Message = ''
        Errtype = ErrType
        Onsite  = 1

        if RELENGERR.has_key(ErrMessage):
           Message    = RELENGERR[ErrMessage][3]
           Errtype    = RELENGERR[ErrMessage][2]
           Errfunc    = RELENGERR[ErrMessage][1]
           ErrModule  = RELENGERR[ErrMessage][0]
        elif RELENGERR.has_key(1000):
           Message    = RELENGERR[1000][3]
           if not(Errtype):
              Errtype    = RELENGERR[1000][2]
           Errfunc    = RELENGERR[1000][1]
           ErrModule  = RELENGERR[1000][0]

        if Message != '' and Errtype != '':
           if Errtype == 'w': 
               print("\nWARNING: %s" %(Message))
           elif Errtype == 'm': 
               print(Message)
           elif Errtype == 'e':
               print("\nERROR: %s" %(Message))
               print("\n") 
               print("Exiting due to fatal error.\n")
               if exit == 0: 
                   sys.exit(1)
    
    def mail(self, smtp_server, subject, message, to, sender):
        """Send an SMTP message without any mime attachments."""
        # check for multiple notification address
        if not re.search(",", to):
           recipient = string.split(to, ",")
        else:
           recipient = to

        try:
            email_msg = MIMEText(message)
            email_msg['Subject'] = subject
            email_msg['From'] = sender
            email_msg['To'] = to
        except:
            print "Cannot create MIMEtext instance."

        try:
           email_server = smtplib.SMTP(smtp_server)
        except:
            print "Cannot send mail using smtplib."

        email_server.set_debuglevel(0)
        email_server.sendmail(sender, recipient, email_msg.as_string())
        email_server.quit()
